Index: cpukit/rtems/Makefile.am
===================================================================
--- cpukit/rtems/Makefile.am	(revision ae85b0663eb19db435476d268a10187633f2ba56)
+++ cpukit/rtems/Makefile.am	(revision ed8b00e667fe179730beb8947b5afb6bcc234d7a)
@@ -185,5 +185,4 @@
 librtems_a_SOURCES += src/msgqtranslatereturncode.c
 librtems_a_SOURCES += src/msgqurgent.c
-librtems_a_SOURCES += src/msgdata.c
 
 ## SEMAPHORE_C_FILES
Index: cpukit/rtems/include/rtems/rtems/messageimpl.h
===================================================================
--- cpukit/rtems/include/rtems/rtems/messageimpl.h	(revision ae85b0663eb19db435476d268a10187633f2ba56)
+++ cpukit/rtems/include/rtems/rtems/messageimpl.h	(revision ed8b00e667fe179730beb8947b5afb6bcc234d7a)
@@ -34,14 +34,4 @@
 
 /**
- *  This constant is defined to extern most of the time when using
- *  this header file.  However by defining it to nothing, the data
- *  declared in this header file can be instantiated.  This is done
- *  in a single per manager file.
- */
-#ifndef RTEMS_MESSAGE_EXTERN
-#define RTEMS_MESSAGE_EXTERN extern
-#endif
-
-/**
  *  The following enumerated type details the modes in which a message
  *  may be submitted to a message queue.  The message may be posted
@@ -65,12 +55,5 @@
  *  manage this class of objects.
  */
-RTEMS_MESSAGE_EXTERN Objects_Information  _Message_queue_Information;
-
-/**
- *  @brief Message Queue Manager Initialization
- *
- *  This routine performs the initialization necessary for this manager.
- */
-void _Message_queue_Manager_initialization(void);
+extern Objects_Information _Message_queue_Information;
 
 /**
Index: cpukit/rtems/src/msg.c
===================================================================
--- cpukit/rtems/src/msg.c	(revision ae85b0663eb19db435476d268a10187633f2ba56)
+++ cpukit/rtems/src/msg.c	(revision ed8b00e667fe179730beb8947b5afb6bcc234d7a)
@@ -21,9 +21,5 @@
 #include <rtems/system.h>
 #include <rtems/config.h>
-#include <rtems/score/chain.h>
-#include <rtems/score/isr.h>
-#include <rtems/score/coremsgimpl.h>
-#include <rtems/score/thread.h>
-#include <rtems/score/wkspace.h>
+#include <rtems/sysinit.h>
 #include <rtems/rtems/status.h>
 #include <rtems/rtems/attrimpl.h>
@@ -32,5 +28,7 @@
 #include <rtems/rtems/support.h>
 
-void _Message_queue_Manager_initialization(void)
+Objects_Information _Message_queue_Information;
+
+static void _Message_queue_Manager_initialization(void)
 {
   _Objects_Initialize_information(
@@ -64,2 +62,8 @@
 
 }
+
+RTEMS_SYSINIT_ITEM(
+  _Message_queue_Manager_initialization,
+  RTEMS_SYSINIT_CLASSIC_MESSAGE_QUEUE,
+  RTEMS_SYSINIT_ORDER_MIDDLE
+);
Index: ukit/rtems/src/msgdata.c
===================================================================
--- cpukit/rtems/src/msgdata.c	(revision ae85b0663eb19db435476d268a10187633f2ba56)
+++ 	(revision )
@@ -1,25 +1,0 @@
-/**
- *  @file
- *
- *  @brief Instantiate the Message Queue Data
- *  @ingroup ClassicMessageQueue
- */
-
-/*
- *  COPYRIGHT (c) 1989-2007.
- *  On-Line Applications Research Corporation (OAR).
- *
- *  The license and distribution terms for this file may be
- *  found in the file LICENSE in this distribution or at
- *  http://www.rtems.org/license/LICENSE.
- */
-
-#if HAVE_CONFIG_H
-#include "config.h"
-#endif
-
-#define RTEMS_MESSAGE_EXTERN
-
-#include <rtems/system.h>
-#include <rtems/rtems/messageimpl.h>
-
Index: cpukit/sapi/src/rtemsapi.c
===================================================================
--- cpukit/sapi/src/rtemsapi.c	(revision ae85b0663eb19db435476d268a10187633f2ba56)
+++ cpukit/sapi/src/rtemsapi.c	(revision ed8b00e667fe179730beb8947b5afb6bcc234d7a)
@@ -30,5 +30,4 @@
 #include <rtems/rtems/clock.h>
 #include <rtems/rtems/dpmemimpl.h>
-#include <rtems/rtems/messageimpl.h>
 #include <rtems/rtems/partimpl.h>
 #include <rtems/rtems/ratemonimpl.h>
@@ -38,5 +37,4 @@
 void _RTEMS_API_Initialize(void)
 {
-  _Message_queue_Manager_initialization();
   _Semaphore_Manager_initialization();
   _Partition_Manager_initialization();
Index: cpukit/score/include/rtems/sysinit.h
===================================================================
--- cpukit/score/include/rtems/sysinit.h	(revision ae85b0663eb19db435476d268a10187633f2ba56)
+++ cpukit/score/include/rtems/sysinit.h	(revision ed8b00e667fe179730beb8947b5afb6bcc234d7a)
@@ -36,4 +36,5 @@
 #define RTEMS_SYSINIT_CLASSIC_SIGNAL             000342
 #define RTEMS_SYSINIT_CLASSIC_EVENT              000343
+#define RTEMS_SYSINIT_CLASSIC_MESSAGE_QUEUE      000344
 #define RTEMS_SYSINIT_IDLE_THREADS               000380
 #define RTEMS_SYSINIT_BSP_LIBC                   000400
Index: testsuites/sptests/spsysinit01/init.c
===================================================================
--- testsuites/sptests/spsysinit01/init.c	(revision ae85b0663eb19db435476d268a10187633f2ba56)
+++ testsuites/sptests/spsysinit01/init.c	(revision ed8b00e667fe179730beb8947b5afb6bcc234d7a)
@@ -26,4 +26,5 @@
 
 #include <rtems/extensionimpl.h>
+#include <rtems/rtems/messageimpl.h>
 #include <rtems/rtems/tasksimpl.h>
 #include <rtems/rtems/timerimpl.h>
@@ -54,4 +55,6 @@
   CLASSIC_EVENT_PRE,
   CLASSIC_EVENT_POST,
+  CLASSIC_MESSAGE_QUEUE_PRE,
+  CLASSIC_MESSAGE_QUEUE_POST,
   IDLE_THREADS_PRE,
   IDLE_THREADS_POST,
@@ -205,4 +208,16 @@
 }
 
+FIRST(RTEMS_SYSINIT_CLASSIC_MESSAGE_QUEUE)
+{
+  assert(_Message_queue_Information.maximum == 0);
+  next_step(CLASSIC_MESSAGE_QUEUE_PRE);
+}
+
+LAST(RTEMS_SYSINIT_CLASSIC_MESSAGE_QUEUE)
+{
+  assert(_Message_queue_Information.maximum != 0);
+  next_step(CLASSIC_MESSAGE_QUEUE_POST);
+}
+
 FIRST(RTEMS_SYSINIT_IDLE_THREADS)
 {
@@ -290,4 +305,6 @@
 #define CONFIGURE_MAXIMUM_USER_EXTENSIONS 1
 
+#define CONFIGURE_MAXIMUM_MESSAGE_QUEUES 1
+
 #define CONFIGURE_MAXIMUM_TASKS 1
 
